include 'ZeroPage.inc'
include 'VVram.inc'
include 'Chars.inc'


ext WallMap_, VVram_, RowFlags_

MapWidth equ VVramWidth
MapHeight equ VVramHeight

pVVram equ ZW1
pSource equ ZW2
pDestination equ ZW3

wallByte equ ZB0
bitCount equ ZB1
yMod equ ZB2
yCount equ ZB3
mapOffset equ ZB4
rowFlag equ ZB5
flagOffset equ ZB6
maskBit equ ZB7


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param0: public	VVramPtr_@Param0
VVramPtr_.x_:	defs 1
VVramPtr_@Param1: public	VVramPtr_@Param1
VVramPtr_.y_:	defs 1
cseg
VVramPtr_: public	VVramPtr_
	pha
        lda	VVramPtr_.y_
        asl a | asl a | asl a  ;*8
        sta <pVVram | lda #0 | sta <pVVram+1
        asl <pVVram | rol <pVVram+1 ;16
        asl <pVVram | rol <pVVram+1 ;32
        lda VVramPtr_.x_ | clc | adc <pVVram | sta <pVVram
        lda <pVVram+1 | adc #0 | sta <pVVram+1
        lda <pVVram | clc|adc #low VVram_ | tay
        lda <pVVram+1 | adc #high VVram_ | tax
	pla
rts


cseg
InitRow:
    lda #low VVram_ | sta <pVVram
    lda #high VVram_ | sta <pVVram+1
    stx <yMod
    lda #MapHeight | sta <yCount
rts

WallMapToVVramRow:
    ldy #0
    do
        lda WallMap_,x | inx
        sta <wallByte
        lda #8/2 | sta <bitCount
        do
            lda <wallByte
            and #3
            if ne
                cmp #3
                if eq
                    lda #Char_HardWall
                else
                    cmp #1
                    if eq
                        lda #Char_Wall
                    else
                        lda #Char_Wall+2
                    endif
                    clc|adc <yMod
                endif
            endif
            sta (<pVVram),y | iny
            lsr <wallByte | lsr <wallByte
            dec <bitCount
        while ne | wend
        cpy #VVramWidth
    while ne | wend
rts

NextRow:
    lda <pVVram | clc|adc #VVramWidth | sta <pVVram
    lda <pVVram+1 | adc #0 | sta <pVVram+1
    lda <yMod | eor #1 | sta <yMod
    dec <yCount
rts

ClearRowFlags:
    ldx #0
    lda #0
    do
        sta RowFlags_,x
        inx
        cpx #3
    while ne | wend
rts


; void WallMapToVVramAll();
cseg
WallMapToVVramAll_: public WallMapToVVramAll_
    pha
        ldx #0
        jsr InitRow
        do
            jsr WallMapToVVramRow
            jsr NextRow
        while ne | wend
        jsr ClearRowFlags
    pla
rts


; void WallMapToVVramChanged();
cseg
WallMapToVVramChanged_: public WallMapToVVramChanged_
    pha
        ldx #0 | stx <mapOffset
        lda RowFlags_,x | sta <rowFlag
        inx | stx <flagOffset
        lda #1 | sta <maskBit
        jsr InitRow
        do
            lda <rowFlag
            and <maskBit
            if ne
                ldx <mapOffset
                jsr WallMapToVVramRow
                stx <mapOffset
            else
                lda <mapOffset
                clc|adc #VVramWidth/(8/2)
                sta <mapOffset
            endif
            asl <maskBit
            if eq
                ldx <flagOffset
                lda RowFlags_,x | sta <rowFlag
                inx | stx <flagOffset
                lda #1 | sta <maskBit
            endif
            jsr NextRow
        while ne | wend
        jsr ClearRowFlags
    pla
rts


; void SetRowFlags(byte y, byte b);
dseg
SetRowFlags_@Param0: public SetRowFlags_@Param0
    defb 0
SetRowFlags_@Param1: public SetRowFlags_@Param1
    defb 0
SetRowFlags_low equ ZB0
SetRowFlags_high equ ZB1
cseg
SetRowFlags_: public SetRowFlags_
    pha
        lda SetRowFlags_@Param1 | sta <SetRowFlags_low
        lda #0 | sta <SetRowFlags_high
       
        lda SetRowFlags_@Param0
        tay
        and #7
        tax
        do | while ne
            asl <SetRowFlags_low | rol <SetRowFlags_high
            dex
        wend
        
        tya
        lsr a | lsr a | lsr a
        tax
        
        lda RowFlags_,x
        ora <SetRowFlags_low
        sta RowFlags_,x
        inx
        lda RowFlags_,x
        ora <SetRowFlags_high
        sta RowFlags_,x
    pla
rts
